"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class IlluminaSummaryCancerV2(ProtocolElement):
    """
    This is the summary provided by illumina for Somatic calls in V2
    (current) of their pipeline Fields of interest include
    `PURITY_TUMOR_PURITY` and `PURITY_TUMOR_PLOIDY`
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "BAMSTATS_NORMAL_GIGABASES_PASSING_FILTER",
        "BAMSTATS_NORMAL_PERCENT_BASES_GE_Q30",
        "BAMSTATS_TUMOR_GIGABASES_PASSING_FILTER",
        "BAMSTATS_TUMOR_PERCENT_BASES_GE_Q30",
        "NORMAL_ID",
        "SVSTATS_CNV_NUMBER_IN_GENES",
        "SVSTATS_CNV_TOTAL",
        "SVSTATS_DELETION_NUMBER_IN_GENES",
        "SVSTATS_DELETION_TOTAL",
        "SVSTATS_INSERTION_NUMBER_IN_GENES",
        "SVSTATS_INSERTION_TOTAL",
        "SVSTATS_INVERSION_NUMBER_IN_GENES",
        "SVSTATS_INVERSION_TOTAL",
        "SVSTATS_TANDEM_DUPLICATION_NUMBER_IN_GENES",
        "SVSTATS_TANDEM_DUPLICATION_TOTAL",
        "SVSTATS_TRANSLOCATION_BREAKEND_TOTAL",
        "TUMOR_ID",
        "VARIANTSTATS_DBSNP_DELETIONS",
        "VARIANTSTATS_DBSNP_INSERTIONS",
        "VARIANTSTATS_DBSNP_SNVS",
        "VARIANTSTATS_FRAMESHIFT_DELETIONS",
        "VARIANTSTATS_FRAMESHIFT_INSERTIONS",
        "VARIANTSTATS_FRAMESHIFT_SNVS",
        "VARIANTSTATS_MATURE_MIRNA_DELETIONS",
        "VARIANTSTATS_MATURE_MIRNA_INSERTIONS",
        "VARIANTSTATS_MATURE_MIRNA_SNVS",
        "VARIANTSTATS_NON_SYNONYMOUS_INSERTIONS",
        "VARIANTSTATS_NON_SYNONYMOUS_SNVS",
        "VARIANTSTATS_NUMBER_IN_CODING_REGIONS_DELETIONS",
        "VARIANTSTATS_NUMBER_IN_CODING_REGIONS_INSERTIONS",
        "VARIANTSTATS_NUMBER_IN_CODING_REGIONS_SNVS",
        "VARIANTSTATS_NUMBER_IN_EXONS_DELETIONS",
        "VARIANTSTATS_NUMBER_IN_EXONS_INSERTIONS",
        "VARIANTSTATS_NUMBER_IN_EXONS_SNVS",
        "VARIANTSTATS_NUMBER_IN_GENES_DELETIONS",
        "VARIANTSTATS_NUMBER_IN_GENES_INSERTIONS",
        "VARIANTSTATS_NUMBER_IN_GENES_SNVS",
        "VARIANTSTATS_SPLICE_SITE_REGION_DELETIONS",
        "VARIANTSTATS_SPLICE_SITE_REGION_INSERTIONS",
        "VARIANTSTATS_SPLICE_SITE_REGION_SNVS",
        "VARIANTSTATS_STOP_GAINED_DELETIONS",
        "VARIANTSTATS_STOP_GAINED_INSERTIONS",
        "VARIANTSTATS_STOP_GAINED_SNVS",
        "VARIANTSTATS_STOP_LOST_DELETIONS",
        "VARIANTSTATS_STOP_LOST_INSERTIONS",
        "VARIANTSTATS_STOP_LOST_SNVS",
        "VARIANTSTATS_SYNONYMOUS_DELETIONS",
        "VARIANTSTATS_SYNONYMOUS_INSERTIONS",
        "VARIANTSTATS_SYNONYMOUS_SNVS",
        "VARIANTSTATS_TOTAL_DELETIONS",
        "VARIANTSTATS_TOTAL_INSERTIONS",
        "VARIANTSTATS_TOTAL_SNVS",
        "VARIANTSTATS_UTR_REGION_DELETIONS",
        "VARIANTSTATS_UTR_REGION_INSERTIONS",
        "VARIANTSTATS_UTR_REGION_SNVS",
        "illumina_version",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_6 import metrics as metrics_1_2_2

        return {
            "illumina_version": metrics_1_2_2.IlluminaVersion,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_6 import metrics as metrics_1_2_2

        return {
            "org.gel.models.report.avro.IlluminaVersion": metrics_1_2_2.IlluminaVersion,
            "org.gel.models.report.avro.IlluminaSummaryCancerV2": metrics_1_2_2.IlluminaSummaryCancerV2,
        }

    __slots__ = [
        "BAMSTATS_NORMAL_GIGABASES_PASSING_FILTER",
        "BAMSTATS_NORMAL_PERCENT_BASES_GE_Q30",
        "BAMSTATS_TUMOR_GIGABASES_PASSING_FILTER",
        "BAMSTATS_TUMOR_PERCENT_BASES_GE_Q30",
        "NORMAL_ID",
        "SVSTATS_CNV_NUMBER_IN_GENES",
        "SVSTATS_CNV_TOTAL",
        "SVSTATS_DELETION_NUMBER_IN_GENES",
        "SVSTATS_DELETION_TOTAL",
        "SVSTATS_INSERTION_NUMBER_IN_GENES",
        "SVSTATS_INSERTION_TOTAL",
        "SVSTATS_INVERSION_NUMBER_IN_GENES",
        "SVSTATS_INVERSION_TOTAL",
        "SVSTATS_TANDEM_DUPLICATION_NUMBER_IN_GENES",
        "SVSTATS_TANDEM_DUPLICATION_TOTAL",
        "SVSTATS_TRANSLOCATION_BREAKEND_TOTAL",
        "TUMOR_ID",
        "VARIANTSTATS_DBSNP_DELETIONS",
        "VARIANTSTATS_DBSNP_INSERTIONS",
        "VARIANTSTATS_DBSNP_SNVS",
        "VARIANTSTATS_FRAMESHIFT_DELETIONS",
        "VARIANTSTATS_FRAMESHIFT_INSERTIONS",
        "VARIANTSTATS_FRAMESHIFT_SNVS",
        "VARIANTSTATS_MATURE_MIRNA_DELETIONS",
        "VARIANTSTATS_MATURE_MIRNA_INSERTIONS",
        "VARIANTSTATS_MATURE_MIRNA_SNVS",
        "VARIANTSTATS_NON_SYNONYMOUS_INSERTIONS",
        "VARIANTSTATS_NON_SYNONYMOUS_SNVS",
        "VARIANTSTATS_NUMBER_IN_CODING_REGIONS_DELETIONS",
        "VARIANTSTATS_NUMBER_IN_CODING_REGIONS_INSERTIONS",
        "VARIANTSTATS_NUMBER_IN_CODING_REGIONS_SNVS",
        "VARIANTSTATS_NUMBER_IN_EXONS_DELETIONS",
        "VARIANTSTATS_NUMBER_IN_EXONS_INSERTIONS",
        "VARIANTSTATS_NUMBER_IN_EXONS_SNVS",
        "VARIANTSTATS_NUMBER_IN_GENES_DELETIONS",
        "VARIANTSTATS_NUMBER_IN_GENES_INSERTIONS",
        "VARIANTSTATS_NUMBER_IN_GENES_SNVS",
        "VARIANTSTATS_SPLICE_SITE_REGION_DELETIONS",
        "VARIANTSTATS_SPLICE_SITE_REGION_INSERTIONS",
        "VARIANTSTATS_SPLICE_SITE_REGION_SNVS",
        "VARIANTSTATS_STOP_GAINED_DELETIONS",
        "VARIANTSTATS_STOP_GAINED_INSERTIONS",
        "VARIANTSTATS_STOP_GAINED_SNVS",
        "VARIANTSTATS_STOP_LOST_DELETIONS",
        "VARIANTSTATS_STOP_LOST_INSERTIONS",
        "VARIANTSTATS_STOP_LOST_SNVS",
        "VARIANTSTATS_SYNONYMOUS_DELETIONS",
        "VARIANTSTATS_SYNONYMOUS_INSERTIONS",
        "VARIANTSTATS_SYNONYMOUS_SNVS",
        "VARIANTSTATS_TOTAL_DELETIONS",
        "VARIANTSTATS_TOTAL_INSERTIONS",
        "VARIANTSTATS_TOTAL_SNVS",
        "VARIANTSTATS_UTR_REGION_DELETIONS",
        "VARIANTSTATS_UTR_REGION_INSERTIONS",
        "VARIANTSTATS_UTR_REGION_SNVS",
        "illumina_version",
        "PURITY_TUMOR_PLOIDY",
        "PURITY_TUMOR_PURITY",
    ]

    def __init__(
        self,
        BAMSTATS_NORMAL_GIGABASES_PASSING_FILTER,
        BAMSTATS_NORMAL_PERCENT_BASES_GE_Q30,
        BAMSTATS_TUMOR_GIGABASES_PASSING_FILTER,
        BAMSTATS_TUMOR_PERCENT_BASES_GE_Q30,
        NORMAL_ID,
        SVSTATS_CNV_NUMBER_IN_GENES,
        SVSTATS_CNV_TOTAL,
        SVSTATS_DELETION_NUMBER_IN_GENES,
        SVSTATS_DELETION_TOTAL,
        SVSTATS_INSERTION_NUMBER_IN_GENES,
        SVSTATS_INSERTION_TOTAL,
        SVSTATS_INVERSION_NUMBER_IN_GENES,
        SVSTATS_INVERSION_TOTAL,
        SVSTATS_TANDEM_DUPLICATION_NUMBER_IN_GENES,
        SVSTATS_TANDEM_DUPLICATION_TOTAL,
        SVSTATS_TRANSLOCATION_BREAKEND_TOTAL,
        TUMOR_ID,
        VARIANTSTATS_DBSNP_DELETIONS,
        VARIANTSTATS_DBSNP_INSERTIONS,
        VARIANTSTATS_DBSNP_SNVS,
        VARIANTSTATS_FRAMESHIFT_DELETIONS,
        VARIANTSTATS_FRAMESHIFT_INSERTIONS,
        VARIANTSTATS_FRAMESHIFT_SNVS,
        VARIANTSTATS_MATURE_MIRNA_DELETIONS,
        VARIANTSTATS_MATURE_MIRNA_INSERTIONS,
        VARIANTSTATS_MATURE_MIRNA_SNVS,
        VARIANTSTATS_NON_SYNONYMOUS_INSERTIONS,
        VARIANTSTATS_NON_SYNONYMOUS_SNVS,
        VARIANTSTATS_NUMBER_IN_CODING_REGIONS_DELETIONS,
        VARIANTSTATS_NUMBER_IN_CODING_REGIONS_INSERTIONS,
        VARIANTSTATS_NUMBER_IN_CODING_REGIONS_SNVS,
        VARIANTSTATS_NUMBER_IN_EXONS_DELETIONS,
        VARIANTSTATS_NUMBER_IN_EXONS_INSERTIONS,
        VARIANTSTATS_NUMBER_IN_EXONS_SNVS,
        VARIANTSTATS_NUMBER_IN_GENES_DELETIONS,
        VARIANTSTATS_NUMBER_IN_GENES_INSERTIONS,
        VARIANTSTATS_NUMBER_IN_GENES_SNVS,
        VARIANTSTATS_SPLICE_SITE_REGION_DELETIONS,
        VARIANTSTATS_SPLICE_SITE_REGION_INSERTIONS,
        VARIANTSTATS_SPLICE_SITE_REGION_SNVS,
        VARIANTSTATS_STOP_GAINED_DELETIONS,
        VARIANTSTATS_STOP_GAINED_INSERTIONS,
        VARIANTSTATS_STOP_GAINED_SNVS,
        VARIANTSTATS_STOP_LOST_DELETIONS,
        VARIANTSTATS_STOP_LOST_INSERTIONS,
        VARIANTSTATS_STOP_LOST_SNVS,
        VARIANTSTATS_SYNONYMOUS_DELETIONS,
        VARIANTSTATS_SYNONYMOUS_INSERTIONS,
        VARIANTSTATS_SYNONYMOUS_SNVS,
        VARIANTSTATS_TOTAL_DELETIONS,
        VARIANTSTATS_TOTAL_INSERTIONS,
        VARIANTSTATS_TOTAL_SNVS,
        VARIANTSTATS_UTR_REGION_DELETIONS,
        VARIANTSTATS_UTR_REGION_INSERTIONS,
        VARIANTSTATS_UTR_REGION_SNVS,
        illumina_version,
        PURITY_TUMOR_PLOIDY=None,
        PURITY_TUMOR_PURITY=None,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_2.IlluminaSummaryCancerV2 model.

        :param BAMSTATS_NORMAL_GIGABASES_PASSING_FILTER:
        :type BAMSTATS_NORMAL_GIGABASES_PASSING_FILTER: double
        :param BAMSTATS_NORMAL_PERCENT_BASES_GE_Q30:
        :type BAMSTATS_NORMAL_PERCENT_BASES_GE_Q30: double
        :param BAMSTATS_TUMOR_GIGABASES_PASSING_FILTER:
        :type BAMSTATS_TUMOR_GIGABASES_PASSING_FILTER: double
        :param BAMSTATS_TUMOR_PERCENT_BASES_GE_Q30:
        :type BAMSTATS_TUMOR_PERCENT_BASES_GE_Q30: double
        :param NORMAL_ID:
        :type NORMAL_ID: str
        :param SVSTATS_CNV_NUMBER_IN_GENES:
        :type SVSTATS_CNV_NUMBER_IN_GENES: double
        :param SVSTATS_CNV_TOTAL:
        :type SVSTATS_CNV_TOTAL: double
        :param SVSTATS_DELETION_NUMBER_IN_GENES:
        :type SVSTATS_DELETION_NUMBER_IN_GENES: double
        :param SVSTATS_DELETION_TOTAL:
        :type SVSTATS_DELETION_TOTAL: double
        :param SVSTATS_INSERTION_NUMBER_IN_GENES:
        :type SVSTATS_INSERTION_NUMBER_IN_GENES: double
        :param SVSTATS_INSERTION_TOTAL:
        :type SVSTATS_INSERTION_TOTAL: double
        :param SVSTATS_INVERSION_NUMBER_IN_GENES:
        :type SVSTATS_INVERSION_NUMBER_IN_GENES: double
        :param SVSTATS_INVERSION_TOTAL:
        :type SVSTATS_INVERSION_TOTAL: double
        :param SVSTATS_TANDEM_DUPLICATION_NUMBER_IN_GENES:
        :type SVSTATS_TANDEM_DUPLICATION_NUMBER_IN_GENES: double
        :param SVSTATS_TANDEM_DUPLICATION_TOTAL:
        :type SVSTATS_TANDEM_DUPLICATION_TOTAL: double
        :param SVSTATS_TRANSLOCATION_BREAKEND_TOTAL:
        :type SVSTATS_TRANSLOCATION_BREAKEND_TOTAL: double
        :param TUMOR_ID:
        :type TUMOR_ID: str
        :param VARIANTSTATS_DBSNP_DELETIONS:
        :type VARIANTSTATS_DBSNP_DELETIONS: double
        :param VARIANTSTATS_DBSNP_INSERTIONS:
        :type VARIANTSTATS_DBSNP_INSERTIONS: double
        :param VARIANTSTATS_DBSNP_SNVS:
        :type VARIANTSTATS_DBSNP_SNVS: double
        :param VARIANTSTATS_FRAMESHIFT_DELETIONS:
        :type VARIANTSTATS_FRAMESHIFT_DELETIONS: double
        :param VARIANTSTATS_FRAMESHIFT_INSERTIONS:
        :type VARIANTSTATS_FRAMESHIFT_INSERTIONS: double
        :param VARIANTSTATS_FRAMESHIFT_SNVS:
        :type VARIANTSTATS_FRAMESHIFT_SNVS: double
        :param VARIANTSTATS_MATURE_MIRNA_DELETIONS:
        :type VARIANTSTATS_MATURE_MIRNA_DELETIONS: double
        :param VARIANTSTATS_MATURE_MIRNA_INSERTIONS:
        :type VARIANTSTATS_MATURE_MIRNA_INSERTIONS: double
        :param VARIANTSTATS_MATURE_MIRNA_SNVS:
        :type VARIANTSTATS_MATURE_MIRNA_SNVS: double
        :param VARIANTSTATS_NON_SYNONYMOUS_INSERTIONS:
        :type VARIANTSTATS_NON_SYNONYMOUS_INSERTIONS: double
        :param VARIANTSTATS_NON_SYNONYMOUS_SNVS:
        :type VARIANTSTATS_NON_SYNONYMOUS_SNVS: double
        :param VARIANTSTATS_NUMBER_IN_CODING_REGIONS_DELETIONS:
        :type VARIANTSTATS_NUMBER_IN_CODING_REGIONS_DELETIONS: double
        :param VARIANTSTATS_NUMBER_IN_CODING_REGIONS_INSERTIONS:
        :type VARIANTSTATS_NUMBER_IN_CODING_REGIONS_INSERTIONS: double
        :param VARIANTSTATS_NUMBER_IN_CODING_REGIONS_SNVS:
        :type VARIANTSTATS_NUMBER_IN_CODING_REGIONS_SNVS: double
        :param VARIANTSTATS_NUMBER_IN_EXONS_DELETIONS:
        :type VARIANTSTATS_NUMBER_IN_EXONS_DELETIONS: double
        :param VARIANTSTATS_NUMBER_IN_EXONS_INSERTIONS:
        :type VARIANTSTATS_NUMBER_IN_EXONS_INSERTIONS: double
        :param VARIANTSTATS_NUMBER_IN_EXONS_SNVS:
        :type VARIANTSTATS_NUMBER_IN_EXONS_SNVS: double
        :param VARIANTSTATS_NUMBER_IN_GENES_DELETIONS:
        :type VARIANTSTATS_NUMBER_IN_GENES_DELETIONS: double
        :param VARIANTSTATS_NUMBER_IN_GENES_INSERTIONS:
        :type VARIANTSTATS_NUMBER_IN_GENES_INSERTIONS: double
        :param VARIANTSTATS_NUMBER_IN_GENES_SNVS:
        :type VARIANTSTATS_NUMBER_IN_GENES_SNVS: double
        :param VARIANTSTATS_SPLICE_SITE_REGION_DELETIONS:
        :type VARIANTSTATS_SPLICE_SITE_REGION_DELETIONS: double
        :param VARIANTSTATS_SPLICE_SITE_REGION_INSERTIONS:
        :type VARIANTSTATS_SPLICE_SITE_REGION_INSERTIONS: double
        :param VARIANTSTATS_SPLICE_SITE_REGION_SNVS:
        :type VARIANTSTATS_SPLICE_SITE_REGION_SNVS: double
        :param VARIANTSTATS_STOP_GAINED_DELETIONS:
        :type VARIANTSTATS_STOP_GAINED_DELETIONS: double
        :param VARIANTSTATS_STOP_GAINED_INSERTIONS:
        :type VARIANTSTATS_STOP_GAINED_INSERTIONS: double
        :param VARIANTSTATS_STOP_GAINED_SNVS:
        :type VARIANTSTATS_STOP_GAINED_SNVS: double
        :param VARIANTSTATS_STOP_LOST_DELETIONS:
        :type VARIANTSTATS_STOP_LOST_DELETIONS: double
        :param VARIANTSTATS_STOP_LOST_INSERTIONS:
        :type VARIANTSTATS_STOP_LOST_INSERTIONS: double
        :param VARIANTSTATS_STOP_LOST_SNVS:
        :type VARIANTSTATS_STOP_LOST_SNVS: double
        :param VARIANTSTATS_SYNONYMOUS_DELETIONS:
        :type VARIANTSTATS_SYNONYMOUS_DELETIONS: double
        :param VARIANTSTATS_SYNONYMOUS_INSERTIONS:
        :type VARIANTSTATS_SYNONYMOUS_INSERTIONS: double
        :param VARIANTSTATS_SYNONYMOUS_SNVS:
        :type VARIANTSTATS_SYNONYMOUS_SNVS: double
        :param VARIANTSTATS_TOTAL_DELETIONS:
        :type VARIANTSTATS_TOTAL_DELETIONS: double
        :param VARIANTSTATS_TOTAL_INSERTIONS:
        :type VARIANTSTATS_TOTAL_INSERTIONS: double
        :param VARIANTSTATS_TOTAL_SNVS:
        :type VARIANTSTATS_TOTAL_SNVS: double
        :param VARIANTSTATS_UTR_REGION_DELETIONS:
        :type VARIANTSTATS_UTR_REGION_DELETIONS: double
        :param VARIANTSTATS_UTR_REGION_INSERTIONS:
        :type VARIANTSTATS_UTR_REGION_INSERTIONS: double
        :param VARIANTSTATS_UTR_REGION_SNVS:
        :type VARIANTSTATS_UTR_REGION_SNVS: double
        :param illumina_version:
        :type illumina_version: IlluminaVersion
        :param PURITY_TUMOR_PLOIDY:
        :type PURITY_TUMOR_PLOIDY: None | double
        :param PURITY_TUMOR_PURITY:
        :type PURITY_TUMOR_PURITY: None | double
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.2"
